# std::multimap<Key,T,Compare,Allocator>::extract

From cppreference.com
< cpp‎ | container‎ | multimap

node_type extract( const_iterator position ); | (1) | (since C++17)
node_type extract( const key_type& x ); | (2) | (since C++17)

1) Unlinks the node that contains the element pointed to by `position` and returns a node handle that owns it
2) If the container has an element with key equivalent to `x`, unlinks the node that contains the first such element from the container and returns a node handle that owns it. Otherwise, returns an empty node handle.

In either case, no elements are copied or moved, only the internal pointers of the container nodes are repointed (rebalancing may occur, as with erase())

Extracting a node invalidates the iterators to the extracted element. Pointers and references to the extracted element remain valid, but cannot be used while element is owned by a node handle: they become usable if the element is inserted into a container.

### Parameters

position | - | a valid iterator into this container
x | - | a key to identify the node to be extracted

### Return value

A node handle that owns the extracted element, or empty node handle in case the element is not found in overload (2)

### Complexity

1) amortized constant
2) log(a.size())

### Notes

extract is the only way to change a key of a map element without reallocation:

    map<int, string> m{{1, "mango"}, {2, "papaya"}, {3, "guava"}};
    auto nh = m.extract(2);
    nh.key() = 4;
    m.insert(move(nh));
    // m == {{1, "mango"}, {3, "guava"}, {4, "papaya"}}

### Example

| This section is incomplete Reason: no example

### See also

merge (C++17) | splices nodes from another container (public member function)
insert | inserts elements or nodes (since C++17) (public member function)
erase | erases elements (public member function)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/container/multimap/extract&oldid=104915"